.if t .ds LX L\\h'-0.36m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds LX LaTeX
.if t .ds TX T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds TX TeX
.ds Ts T\s-2RAN\s+2S\s-2CRIPT\s+2
.if t .ds Uc \fIU\\h'-0.12m'C\\v'0.27m'\\h'-.23m'S\\h'-0.11m'F\\v'-0.27m'\fP
.if n .ds Uc UCSF
.ds Et \\f(boE\\h'-0.1667m'\\v'-0.20v'T\\v'0.20v'\\h'-0.125m'T\\fP
.\" .SS "subsection title"
.de SS
.PP
.ne 3
.ti -0.25i
\fB\\$1\fP
.br
..
.TH MAKEINDEX 1L "11 April 1994" "" "Version 2.13 (beta)"
.\"=====================================================================
.SH NAME
makeindex \- a general purpose, formatter-independent index processor
.\"=====================================================================
.SH SYNOPSIS
.B makeindex
.RB [ \-c ]
.RB [ \-d ]
.RB [ \-e
.IR errfile ]
.RB [ \-g ]
.RB [ \-i ]
.RB [ \-l ]
.RB [ \-o
.IR ind ]
.RB [ \-p
.IR num ]
.RB [ \-q ]
.RB [ \-r ]
.RB [ \-s
.IR sfile ]
.RB [ \-t
.IR log ]
.BR
.if n .ti +9n
.if t .ti +.5i
.RI [ idx1
.I idx2
.IR idx3 .\|.\|.]
.\"=====================================================================
.SH DESCRIPTION
The program
.I makeindex
is a general purpose hierarchical index generator; it accepts one or
more input files, often produced by a text formatter such as \*(TX
.RI ( tex (1L))
or
.IR troff (1),
sorts the entries, and produces an output file which can be formatted.
The index can have up to three levels (0, 1, and 2) of subitem nesting.
.PP
The way in which words are flagged for indexing within the main document
is specific to the formatter used;
.I makeindex
does
.I not
automate the process of selecting these words.
.PP
As the output index is hierarchical,
.I makeindex
can be considered complimentary to the
.IR awk (1)-based
.IR make.index (1L)
system of Bentley and Kernighan, which is specific to
.IR troff (1),
generates non-hierarchical indices, and employs a much simpler syntax
for indicating index entries.  For illustration of use with
.I troff
and
.IR \*(TX ,
see the section \s-2EXAMPLES\s+2 below.
.LP
The formats of the input and output files are
specified in a style file; by default, input is assumed to be a
.I \&.idx
file, as generated by \*(LX or \*(TX.
.LP
Unless specified explicitly, the base name of the first input file
.RI ( idx1 )
is used to determine the names of other files.  For each input file
name specified, a file of that name is sought.  If this file is not
found and the file name has no extension, the extension
.I \&.idx
is appended.  If no file with this name is found,
.I makeindex
aborts.
.LP
If exactly one input file was given and no explicit style file was
specified using
.BR \-s ,
.I makeindex
uses a file with the extension
.I \&.mst
as default style file (when present).
.LP
Errors in style files and index entries are logged and counted, but
do not terminate processing.  When
.I makeindex
terminates, it will do so with a non-zero exit status if any errors
were found.  Some operating systems permit the exit status to control
further execution of commands.
.LP
For important notes on how to select index keywords, see the document
by Lamport cited below.  As an issue separate from selecting index
keywords, a systematic mechanism for placing index terms in a document
is suggested in
.IR "Index Preparation and Processing" ,
a paper cited below.
.LP
Ports of
.I makeindex
to most operating systems are available.  On those systems with severe
file name length restrictions, such as the IBM PC, you should expect
its name to be shortened, to something like
.I makeindx
or
.IR makidx .
.\"=====================================================================
.SH OPTIONS
Command-line options are normally introduced by a leading hyphen, as
is conventional on UNIX.  On other operating systems,
.I makeindex
may be compiled with an alternate option prefix, such as forward slash
for DEC VMS and IBM PC systems.  We follow the UNIX conventions in
this document, but the alternative prefixes are to be substituted on
other operating systems.
.\"---------------------------------------------------------------------
.\" .TP \w'\-e filename'u+2n  <-- should work, but gets a 'line cannot be broken' with groff
.TP 12
.B \-c
Compress intermediate blanks, and ignore leading and trailing blanks
and tabs.  By default, blanks in the index key are retained.
.\"---------------------------------------------------------------------
.TP
.B \-d
Dump the index style specifications in a form suitable for later
inclusion in a style file, and print debug output displaying memory
allocation information and the internal forms of the index before and
after sorting.  The output is voluminous, so you probably do not want
to select it for a large index file.  Output is to
.IR stderr ,
but this can be redirected to a file (see
.B \-e
below).
.\"---------------------------------------------------------------------
.TP
.BI \-e filename
Redirect
.I stderr
to the named file.  As a special case, if the filename is a hyphen,
then
.I stderr
is redirected to
.IR stdout .
This option may be useful for capturing debug output in a file on
those systems (e.g. IBM PC) where run-time redirection of
.I stderr
to a file is difficult, or impossible.
.\"---------------------------------------------------------------------
.TP
.B \-g
Employ German word ordering in the index, in accord with rules set forth
in the German Industrial Standard DIN 5007.  The normal
.I makeindex
word ordering precedence is: symbols, numbers, uppercase letters,
lowercase letters.  The sequence in German word ordering is: symbols,
lowercase letters, uppercase letters, numbers.  In both orderings,
case is ignored when grouping letters, so the ordering is
.I "A a B b C c .\|.\|."
(normal), or
.I "a A b B c C .\|.\|."
(German),
.I not
.I "A B C .\|.\|. a b c .\|.\|."
or
.I "a b c .\|.\|. A B C .\|.\|."
Additionally, this option enables recognition of the German \*(TX
commands {"a, "o, "u and "s} as {ae, oe, ue and ss} during the sorting
of the entries, and redefines the default quote character to '+'.
.\"---------------------------------------------------------------------
.TP
.B \-i
Take input from
.IR stdin .
When this option is specified and
.B \-o
is not, output is written to
.IR stdout ,
allowing
.I makeindex
to be used as a filter, perhaps in a command-shell pipeline.
.\"---------------------------------------------------------------------
.TP
.B \-l
Letter ordering; by default, word ordering is used (see
the \s-2ORDERING\s+2 section).
.\"---------------------------------------------------------------------
.TP
.BI \-o " ind"
Employ
.I ind
as the output index file.  By default, the file name
is created by appending the extension
.I .ind
to the base name of
the first input file
.RI ( idx1 ).
.\"---------------------------------------------------------------------
.TP
.BI \-p " num"
Set the starting page number of the output index file to be
.I num
(useful when the index file is to be formatted separately).  The
argument
.I num
may be numerical or one of the following:
.RS
.TP
.I any
The starting page is the last source page number plus 1.
.TP
.I odd
The starting page is the first odd page following the last source page
number.
.TP
.I even
The starting page is the first even page following the last source
page number.
.RE
.IP
The last source page is obtained by searching backward in the log file
for the first instance of a number included within paired square
brackets
.RB ( [ .\|.\|. ] ).
If a page number is missing or the log file is not found, no attempt
will be made to set the starting page number.  The source log file
name is determined by appending the extension
.I \&.log
to the base name of the first input file
.RI ( idx1 ).
.\"---------------------------------------------------------------------
.TP
.B \-q
Quiet mode; send no messages to
.IR stderr .
By default, progress
and error messages are sent to
.I stderr
as well as to the
transcript file.
.\"---------------------------------------------------------------------
.TP
.B \-r
Disable implicit page range formation; page ranges must be created by
using explicit range operators; see \s-2SPECIAL EFFECTS\s+2 below.  By
default, three or more successive pages are automatically abbreviated
as a range (e.g. 1\(en5).
.\"---------------------------------------------------------------------
.TP
.BI \-s " sty"
Employ
.I sty
as the style file (no default).  The environment
variable \s-2INDEXSTYLE\s+2 defines the path where the style file
should be found.
.\"---------------------------------------------------------------------
.TP
.BI \-t " log"
Employ
.I log
as the transcript file.  By default, the file name is
created by appending the extension
.I .ilg
to the base name of the
first input file
.RI ( idx1 ).
.\"=====================================================================
.SH "STYLE FILE"
The style file informs
.I makeindex
about the format of the
.I \&.idx
input files and the intended format of the final output file; examples
appear below.  The style file, which can reside anywhere in the path
defined by the environment variable \s-2INDEXSTYLE\s+2, contains a
list of
.RI < specifier , " attribute" >
pairs separated by arbitrary whitespace (blank, tab, or newline).
These pairs do not have to appear in any particular order.  Repeated
specifiers override earlier ones.
.PP
Attribute values are strings, characters, or numbers:
.IP
A <string> is arbitrary text delimited by double quotes (".\|.\|.").
Inside the <string>, \\n represents a newline character, \\t a
horizontal tab character, \\\\ a backslash, and \\<other> represents
the single character <other>.  Unbackslashed newlines are also
permitted, so that multiline <string> values can be made more
readable.  A NUL character in the text terminates the <string> value,
so only 255 different characters can be represented.  This limitation
arises from the C programming language used to implement
.IR makeindex .
The maximum length of a <string> is
.\" 5000 is the value of ARRAY_MAX in ../src/mkind.h.
.B 5000
characters.
.IP
A <char> is a single character, or a backslash-character pair,
embraced by single quotes ('x' or '\\x').  The backslash conventions
for <string> apply to <char>; thus, a single quote must be represented
by '\\''.  All 256 possible characters can be represented, including
NUL.  A newline can be represented as '\\n', '<newline>',
or '\\<newline>', where <newline> is a literal newline character.
.IP
A <number> is an optionally-signed decimal integer.
.PP
Outside <char> and <string> values, a percent, `%', initiates a
comment that continues up to, and including, the next newline.
Comment may occur anywhere that whitespace can appear.
.PP
Use the
.B \-d
option with an empty index file to get a neatly formatted tabulation
of all specifiers and their attribute values for subsequent
modification and use as a style file.  For example, you can trap the
style file output in a file named
.I foo.mst
on UNIX with the command
.PP
.nf
\fCmakeindex \-d \-e foo.mst \-i \-q \-t /dev/null </dev/null >/dev/null\fP
.fi
.PP
This information is written
.I after
any input style file has been processed, so it includes all changes
made by the style file.
.PP
Errors in style files result in warning messages to
.IR stderr ,
and to the transcript file, but
.I makeindex
continues execution; it will, however, terminate with a non-zero exit
status.
.PP
Default values are provided for all attributes.  They are shown at the
head of the rightmost column in the following descriptions of input
and output specifiers.
.\"----------------------------------------------------------------------
.SS "INPUT STYLE SPECIFIERS"
.TP 25
.BR actual " <char>"
\'@\'
.RS
Symbol indicating that the next entry is to appear in the output file.
.RE
.TP
.BR arg_close " <char>"
\'}\'
.RS
Closing delimiter for the index entry argument.
.RE
.TP
.BR arg_open " <char>"
\'{\'
.RS
Opening delimiter for the index entry argument.
.RE
.TP
.BR encap " <char>"
\'|\'
.RS
Symbol indicating that the rest of the argument list
is to be used as the encapsulating command for the page number.
.RE
.TP
.BR escape " <char>"
\'\\\\\'
.RS
Symbol which escapes the following letter, unless its preceding letter
is
.BR escape .
Note:
.B quote
is used to escape the letter which immediately follows it, but if it is
preceded by
.BR escape ,
it is treated as a ordinary character.  These two symbols
.I must
be distinct.
.RE
.TP
.BR keyword " <string>"
"\\\\indexentry"
.RS
Command which tells
.I makeindex
that its argument is an index entry.
.RE
.TP
.BR level " <char>"
\'!\'
.RS
Delimiter denoting a new level of subitem.
.RE
.TP
.BR page_compositor " <string>"
"-"
.RS
String which separates values in a composite page number.
With the default compositor string, page number
.I "A-3"
would be recognized as the third page of Appendix A.
.RE
.TP
.BR quote " <char>"
\'"\'
.RS
Note:
.B quote
is used to escape the letter which immediately follows it, but if it
is preceded by
.BR escape ,
it is treated as a ordinary character.  These two symbols
.I must
be distinct.  If German word ordering is selected by the
.B \-g
command-line option, the
.B quote
character
.I must
be redefined in a style file.
.RE
.TP
.BR range_close " <char>"
\')\'
.RS
Closing delimiter indicating the end of an explicit page range.
.RE
.TP
.BR range_open " <char>"
\'(\'
.RS
Opening delimiter indicating the beginning of an explicit page range.
.RE
.\"---------------------------------------------------------------------
.SS "OUTPUT STYLE SPECIFIERS"
The default settings for the output style specifiers are suitable for
standard \*(TX and \*(LX, so users of those document preparation
systems will rarely need to provide alternate values.
.TP 25
.BR delim_0 " <string>"
", "
.RS
Delimiter to be inserted between a level 0 key and its first page number
(default: comma followed by a blank).
.RE
.TP
.BR delim_1 " <string>"
", "
.RS
Delimiter to be inserted between a level 1 key and its first page number
(default: comma followed by a blank).
.RE
.TP
.BR delim_2 " <string>"
", "
.RS
Delimiter to be inserted between a level 2 key and its first page number
(default: comma followed by a blank).
.RE
.TP
.BR delim_n " <string>"
", "
.RS
Delimiter to be inserted between two page numbers for the same key
in any level (default: comma followed by a blank).
.RE
.TP
.BR delim_r " <string>"
"--"
.RS
Delimiter to be inserted between the starting and ending page numbers
of a range.
.RE
.TP
.BR delim_t " <string>"
""
.RS
Delimiter to be inserted at the end of a page list.  This delimiter
has no effect on entries which have no associated page list.
.RE
.TP
.BR encap_infix " <string>"
"{"
.RS
Second part of prefix for the command which encapsulates the page
number.
.RE
.TP
.BR encap_prefix " <string>"
"\\\\"
.RS
First part of prefix for the command which encapsulates the page number.
.RE
.TP
.BR encap_suffix " <string>"
"}"
.RS
Suffix for the command which encapsulates the page number.
.RE
.TP
.BR group_skip " <string>"
"\\n\\n  \\\\indexspace\\n"
.RS
Vertical space to be inserted before a new group begins.
.RE
.TP
.BR heading_prefix " <string>"
""
.RS
Header prefix to be inserted before a new letter begins.
.RE
.TP
.BR heading_suffix " <string>"
""
.RS
Header suffix to be inserted after a new letter begins.
.RE
.TP
.BR headings_flag " <number>"
0
.RS
Flag indicating treatment of new group headers, which are inserted
when before a new group (symbols, numbers, and the 26 letters):
positive values cause an uppercase letter to be inserted between
prefix and suffix, and negative values cause a lowercase letter to be
inserted (default is 0, which produces no header).
.RE
.TP
.BR indent_length " <number>"
16
.RS
Length of
.B indent_space
(default: 16, equivalent to 2 tabs).
.RE
.TP
.BR indent_space " <string>"
"\\t\\t"
.RS
Space to be inserted in front of a wrapped line (default: two tabs).
.RE
.TP
.BR item_0 " <string>"
"\\n  \\\\item "
.RS
Command to be inserted between two primary (level 0) items.
.RE
.TP
.BR item_01 " <string>"
"\\n    \\\\subitem "
.RS
Command to be inserted between a level 0 item and a level 1 item.
.RE
.TP
.BR item_1 " <string>"
"\\n     \\\\subitem "
.RS
Command to be inserted between two secondary (level 1) items.
.RE
.TP
.BR item_12 " <string>"
"\\n    \\\\subsubitem "
.RS
Command to be inserted between a level 1 item and a level 2 item.
.RE
.TP
.BR item_2 " <string>"
"\\n       \\\\subsubitem "
.RS
Command to be inserted between two level 2 items.
.RE
.TP
.BR item_x1 " <string>"
"\\n    \\\\subitem "
.RS
Command to be inserted between a level 0 item and a level 1 item,
where the level 0 item does not have associated page numbers.
.RE
.TP
.BR item_x2 " <string>"
"\\n    \\\\subsubitem "
.RS
Command to be inserted between a level 1 item and a level 2 item,
where the level 1 item does not have associated page numbers.
.RE
.TP
.BR line_max " <number>"
72
.RS
Maximum length of a line in the output index, beyond which a line
wraps.  This is
.I not
a strict limit, because line breaks are never introduced in index
entry text.
.RE
.TP
.BR numhead_negative " <string>"
"numbers"
.RS
Heading for numbers to be inserted if
.B headings_flag
is negative.
.RE
.TP
.BR numhead_positive " <string>"
"Numbers"
.RS
Heading for numbers to be inserted if
.B headings_flag
is positive.
.RE
.TP
.BR page_precedence " <string>"
"rnaRA"
.RS
String which defines the output order of various types of page
numbers.  There should be up to five letters selected without
duplication from the following list, in the required order:
.B a
(alphabetic lowercase),
.B A
(alphabetic uppercase),
.B n
(Arabic digits),
.B r
(Roman lowercase),
and
.B R
(Roman uppercase).
.PP
The default page number precedence string corresponds to that
conventionally used in English-language books, where lowercase Roman
numerals are used in front matter, Arabic numbers for the main body,
and possibly composite page numbers beginning with a letter or an
uppercase Roman numeral for appendices.
.RE
.TP
.BR postamble " <string>"
"\\n\\n\\\\end{theindex}\\n"
.RS
Postamble of output file.
.RE
.TP
.BR preamble " <string>"
"\\\\begin{theindex}\\n"
.RS
Preamble of output file.
.RE
.TP
.BR setpage_prefix " <string>"
"\\n  \\\\setcounter{page}{"
.RS
Prefix of command which sets the starting page number.
.RE
.TP
.BR setpage_suffix " <string>"
"}\\n"
.RS
Suffix of command which sets the starting page number.
.RE
.TP
.BR suffix_2p " <string>"
""
.RS
Delimiter to replace the range delimiter and the second page number of
a two-page list.  When present, it overrides
.BR delim_r .
Example: "f.".
.RE
.TP
.BR suffix_3p " <string>"
""
.RS
Delimiter to replace the range delimiter and the second page number of
a three-page list.  When present, it overrides
.B delim_r
and
.BR suffix_mp .
Example: "ff.".
.RE
.TP
.BR suffix_mp " <string>"
""
.RS
Delimiter to replace the range delimiter and the second page number of
a multiple page list (three or more pages). When present, it overrides
.BR delim_r .
Example: "f.".
.RE
.TP
.BR symhead_negative " <string>"
"symbols"
.RS
Heading for symbols to be inserted if
.B headings_flag
is negative.
.RE
.TP
.BR symhead_positive " <string>"
"Symbols"
.RS
Heading for symbols to be inserted if
.B headings_flag
is positive.
.RE
.\"=====================================================================
.SH EXAMPLES
.\"---------------------------------------------------------------------
.SS "BUILT-IN DEFAULTS"
The following example shows a style file produced by the command
.PP
.nf
\fCmakeindex \-d \-e foo.mst \-i \-q \-t /dev/null </dev/null >/dev/null\fP
.fi
.PP
It is a convenient starting point if you wish to modify style
specifiers.
.PP
.nf
\fC%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% makeindex portable version 2.13 (beta) [09-Apr-1994]

%% Input style file specifiers

actual                  '@'
arg_close               '}'
arg_open                '{'
encap                   '|'
escape                  '\\\\'
keyword                 "\\\\indexentry"
level                   '!'
page_compositor         "-"
quote                   '\\"'
range_close             ')'
range_open              '('

%% Output style file specifiers

delim_0                 ", "
delim_1                 ", "
delim_2                 ", "
delim_n                 ", "
delim_r                 "--"
delim_t                 ""
encap_infix             "{"
encap_prefix            "\\\\"
encap_suffix            "}"
group_skip              "\\n\\n  \\\\indexspace\\n"
heading_prefix          ""
heading_suffix          ""
headings_flag           0
indent_length           16
indent_space            "\\t\\t"
item_0                  "\\n  \\\\item "
item_01                 "\\n    \\\\subitem "
item_1                  "\\n    \\\\subitem "
item_12                 "\\n      \\\\subsubitem "
item_2                  "\\n      \\\\subsubitem "
item_x1                 "\\n    \\\\subitem "
item_x2                 "\\n      \\\\subsubitem "
line_max                72
numhead_negative        "numbers"
numhead_positive        "Numbers"
page_precedence         "rnaRA"
postamble               "\\n\\n\\\\end{theindex}\\n"
preamble                "\\\\begin{theindex}\\n"
setpage_prefix          "\\n  \\\\setcounter{page}{"
setpage_suffix          "}\\n"
suffix_2p               ""
suffix_3p               ""
suffix_mp               ""
symhead_negative        "symbols"
symhead_positive        "Symbols"

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\fP
.fi
.\"---------------------------------------------------------------------
.SS "\*(TX EXAMPLE"
The following example shows a style file called
.IR book.mst ,
which defines an index for a book which can be formatted independently
of the main source:
.LP
.RS
.nf
\fCpreamble
"\\\\documentstyle[12pt]{book}
\\\\begin{document}
\\\\begin{theindex}
{\\\\small\\n"
postamble
"\\n\\n}
\\\\end{theindex}
\\\\end{document}\\n\fP"
.fi
.RE
.LP
Assuming that a particular book style requires the index (as well as any
chapters) to start from an odd page number, and that the input file is
named
.IR foo.idx ,
the following command line produces output in file
.IR footmp.ind :
.LP
.RS
\fCmakeindex  \-s book.mst  \-o footmp.ind  \-p odd  foo\fP
.RE
.LP
Here a non-default output file name is used to avoid clobbering the
output for the book itself (presumably
.IR foo.ind ,
which would have been the default name for the index output file!).
.\"---------------------------------------------------------------------
.SS "TROFF EXAMPLE"
A sample control file for creating an index, which we will assume
resides in the file
.IR sample.mst :
.LP
.RS
.nf
\&\fCkeyword "IX:"
\&preamble
\&".\\\\\\" start of index output
\&\\".\\\\\\" enter two column mode
\&.2C
\&.SH
\&.ce
\&INDEX
\&.XS
\&INDEX
\&.XE
\&.R
\&.ps 9p
\&.vs 11p
\&.sp
\&.de I1
\&.ti 0.25i
\&..
\&.de I2
\&.ti 0.5i
\&.."
\&postamble "\\n.\\\\\\" end of index output"
\&setpage_prefix "\\n.nr % "
\&setpage_suffix ""
\&group_skip "\\n.sp 1.0"
\&headings_flag 1
\&heading_prefix "\\n.IS\\n"
\&heading_suffix "\\n.IE"
\&item_0 "\\n.br\\n"
\&item_1 "\\n.I1\\n"
\&item_2 "\\n.I2\\n"
\&item_01 "\\n.I1\\n"
\&item_x1 "\\n.I1\\n"
\&item_12 "\\n.I2\\n"
\&item_x2 "\\n.I2\\n"
\&delim_0 ", "
\&delim_1 ", "
\&delim_2 ", "
\&delim_r "-"
\&delim_t "."
\&encap_prefix "\\\\fB"
\&encap_infix ""
\&encap_suffix "\\\\fP"
\&indent_space ""
\&indent_length 0\fP
.fi
.RE
.LP
The local macro package may require modification, as in this example
of an extension to the
.B \-ms
macros (note that at some sites, this macro should
.I replace
a pre-existing macro of the same name):
.LP
.RS
.nf
\fC\&.\" IX - index words to stderr
\&.de IX
\&.ie '\\\\n(.z'' .tm IX: \\\\$1 \\\\$2 \\\\$3 \\\\$4 \\\\$5 \\\\$6 \\\\$7 \\\\$8 \\\\$9 {\\\\n(PN}
\&.el \\\\!.IX \\\\$1 \\\\$2 \\\\$3 \\\\$4 \\\\$5 \\\\$6 \\\\$7 \\\\$8 \\\\$9 {\\\\n(PN}
\&..\fP
.fi
.RE
.LP
(note that the string {\fC\\\\n(PN\fP} is separated from the rest of the
line by a tab.
If your local macro package does not contain this extension,
just include those lines at the beginning of your file.
Here is a simple
.IR troff (1)
input file, which we will assume is named
.IR sample.txt :
.LP
.RS
.nf
\fC\&This is a sample file to test the \\fImakeindex\\fP(1L)
\&program, and see
\&.IX {indexing!programs!C language}
\&.IX {makeindex@\\fImakeindex\\fP(1L)}
\&.bp
\&.rs
\&.IX {Knuth}
\&.IX {typesetting!computer-aided}
\&how well it functions in the \\fItroff\\fP(1) environment.\fP
.fi
.RE
.LP
Note that index entries are indicated by the
.B .IX
macro, which
causes the following text to be written to
.I stdout
along with the
current page number.
.\"---------------------------------------------------------------------
.SS "CREATING THE INDEX FILE IN THE UNIX BOURNE SHELL"
To create an input file for
.IR makeindex ,
in the UNIX Bourne shell environment, do the equivalent at your site
of the command:
.LP
.nf
\fCpsroff -ms -Tpsc -t sample.txt > /dev/null 2> sample.tmp\fP
.fi
.LP
Some sites will require
.I ditroff
instead of
.IR psroff .
To filter out any genuine error messages, invoke
.IR grep (1):
.LP
.RS
\fCgrep '^IX: ' sample.tmp > sample.idx\fP
.RE
.\"---------------------------------------------------------------------
.SS "CREATING THE INDEX FILE USING \*(Uc ENHANCED TROFF/\*(Ts"
With \*(Uc Enhanced troff/\*(Ts, the
.B \-I
option of
.IR psroff (1L)
can produce both formatter output and an index file:
.LP
.RS
\fCpsroff -ms -I sample.inp -Tpsc sample.txt\fP
.RE
.LP
If it is wished to suppress the formatter output:
.RS
.LP
.nf
\fCpsroff -ms -I sample.inp -Tpsc -t sample.txt > /dev/null\fP
.fi
.RE
.\"---------------------------------------------------------------------
.SS "COMPLETING THE INDEX"
Any of the above procedures leaves the input for
.I makeindex
in
.IR sample.inp .
The next step is to invoke
.IR makeindex :
.LP
.RS
\fCmakeindex -s sample.mst sample.idx\fP
.RE
.LP
This leaves
.IR troff (1)-ready
output in the file
.IR sample.ind .
.\"=====================================================================
.SH "ORDERING OF INDEX ITEMS"
By default,
.I makeindex
assumes
.IR "word ordering" ;
if the
.B \-l
option is in effect,
.I "letter ordering"
is used.  In word ordering, a blank precedes any letter in the
alphabet, whereas in letter ordering, it does not count at all.  This
is illustrated by the following example:
.LP
.RS
\fIword order                      letter order\fP
.br
sea lion                        seal
.br
seal                            sea lion
.RE
.LP
Numbers are always sorted in numeric order.  For instance,
.LP
.RS
9 (nine),  123
.br
10 (ten), see Derek, Bo
.RE
.LP
Letters are first sorted without regard to case; when words are
identical, the uppercase version precedes its lowercase counterpart.
The German ordering option,
.BR \-g ,
puts lowercase before uppercase.
.LP
A special symbol is defined here to be any character not appearing in
the union of digits and the English alphabetic characters.  Patterns
starting with special symbols precede numbers, which precede patterns
starting with letters.  As a special case, a string starting with a
digit but mixed with non-digits is considered to be a pattern starting
with a special character.
.\"=====================================================================
.SH "ORDERING OF PAGE NUMBERS"
.I makeindex
recognizes both
.I simple
and
.I composite
page numbers.
.LP
A
.I "simple page number"
may be one of six different types: an Arabic number, an Arabic number
followed by an arbitrary string, a lowercase Roman number, an
uppercase Roman number, a single lowercase letter, or a single
uppercase letter.  Because Roman numbers are represented with the
letters
.IR i (1),
.IR v (5),
.IR x (10),
.IR l (50),
.IR c (100),
.IR d (500),
and
.IR m (1000),
and their uppercase equivalents, the two letter types may not be
distinguishable from Roman numbers.  The ambiguity is always resolved
in favor of Roman numbers.  Examples of simple page numbers are
.IR 123 ,
.IR 258abc ,
.IR xxiv ,
.IR MCMXCIV ,
.IR y ,
and
.IR Z .
.LP
.IR makeindex 's
internal representation of page numbers is limited by the size of the
C programming language integer data type,
.IR int ,
and the need to distinguish between different types of page numbers.
On 32-bit machines,
.I makeindex
therefore restricts Arabic and Roman numbers to values in the range
0 .\|.\|. 99999999.  On small machines, it is possible to compile a
version that uses only 16-bit integers, in which case page number
values are limited to the range 0 .\|.\|. 9999.
.LP
A
.I "composite page number"
is a simple page number separated from a composite page number by the
compositor character, which is settable by a
.BR page_compositor " <string>"
entry in a style file.  Examples of composite numbers are:
.IR 10-8-2 ,
.IR 12-a ,
.IR IV-3 ,
and
.IR A-1 .
.LP
For sorting purposes, each of the six types of simple page numbers is
represented as a biased integer in non-overlapping ranges.  The
default sort order of these six types can be altered by the
.BR page_precedence " <string>"
style file option.  Sorting is done according to the first simple
number, then according to the second, third, .\|.\|. numbers.  In the
event a simple page number consists of a digit string followed by an
arbitrary string (e.g.
.IR 117a ),
sorting is first by the value of the
digit string, then for equal digit strings, by ordinary alphanumeric
ordering.  Thus, with the default page precedence, the numbers
.IR 1 ,
.IR 12 ,
.IR 12a ,
.IR 12ab ,
.IR 12abc ,
.IR 12A ,
.IR 12-1 ,
.IR a-1 ,
and
.I A-1
are in sorted order.
.LP
Although reasonable efforts are made to detect incorrect page numbers,
for Roman numbers, equivalent, if unconventional, forms are accepted:
.IR iiiiiiiii ,
.IR viiii ,
and
.I ix
all reduce to the value
.I 9
for sorting and ordering purposes.
.LP
The maximum length of a composite page number, and the number of
simple page numbers in a composite page number, can be set at compile
time; they are at least
.BR 100 ,
and
.BR 50 ,
respectively.
.\"=====================================================================
.SH "SPECIAL EFFECTS"
Entries such as
.LP
.RS
.nf
\fC\\indexentry{alpha}{1}
\\indexentry{alpha!beta}{3}
\\indexentry{alpha!beta!gamma}{10}\fP
.fi
.RE
.LP
in the input file will be converted to
.LP
.RS
.nf
\fC\\item alpha, 1
\0\0\0\\subitem beta, 3
\0\0\0\0\0\0\\subsubitem gamma, 10\fP
.fi
.RE
.LP
in the output index file.
Notice that the
.B level
symbol (`!') is used above to delimit
hierarchical levels.
.LP
It is possible to make an item appear in a designated form by
using the
.B actual
(`@') operator.  For instance,
.LP
.RS
\fC\\indexentry{alpha@{\\it alpha\\/}}{1}\fP
.RE
.LP
will become
.LP
.RS
\fC\\item {\\it alpha\\/},  1\fP
.RE
.LP
after processing.  The pattern preceding `@' is
used as sort key, whereas the one following it is written to the
output file.  Note that two appearances of the same key, one with and
one without the
.B actual
operator, are regarded as
.I distinct
entries.
.LP
The item, subitem, and subsubitem fields may have individual sort keys:
.LP
.RS
.nf
\fC\\indexentry{aa@{\\it aa\\/}!bb@{\\it bb\\/}!cc@{\\it cc\\/}}{1}\fP
.fi
.RE
.LP
This will be converted to
.LP
.RS
.nf
\fC\\item {\\it aa}, 1
\0\0\0\\subitem {\\it bb}, 3
\0\0\0\0\0\0\\subsubitem {\\it cc}, 10\fP
.fi
.RE
.LP
It is possible to encapsulate a page number with a designated
command using the
.B encap
(`|') operator:
.LP
.RS
\fC\\indexentry{alpha|bold}{1}\fP
.RE
.LP
will be converted to
.LP
.RS
\fC\\item alpha, \\bold{1}\fP
.RE
.LP
where, with a suitable definition for \*(TX, \fC\\bold{n}\fP
will expand to \fC{\\bf n}\fP.
In this example, the three output attributes associated with page
encapsulation
.BR encap_prefix ,
.BR encap_infix ,
and
.BR encap_suffix ,
correspond to backslash, left brace, and right brace, respectively.
This mechanism allows page numbers to be set in different fonts.  For
example, the page where the definition of a keyword appears can be in
one font, the location of a primary example can be in another font,
and other appearances in yet a third font.
.LP
The
.B encap
operator can also be used to create cross references in
the index:
.LP
.RS
\fC\\indexentry{alpha|see{beta}}{1}\fP
.RE
.LP
will become
.LP
.RS
\fC\\item alpha, \\see{beta}{1}\fP
.RE
.LP
in the output file, where
.LP
.RS
\fC\\see{beta}{1}\fP
.RE
.LP
will expand to
.LP
.RS
\fC{\\it see\\/} beta\fP
.RE
.LP
Note that in a cross reference like this the page number disappears.
.LP
A pair of
.B encap
concatenated with
.B range_open
(`|(') and
.B range_close
(`|)') creates an explicit page range:
.LP
.RS
.nf
\fC\\indexentry{alpha|(}{1}
\\indexentry{alpha|)}{5}\fP
.fi
.RE
.LP
will become
.LP
.RS
\fC\\item alpha, 1\(em5\fP
.RE
.LP
Intermediate pages indexed by the same key will be merged into the
range implicitly.  This is especially useful when an entire section
about a particular subject is to be indexed, in which case only the
range opening and closing operators need to be inserted at the
beginning and end of the section.  Explicit page range formation can
also include an extra command to set the page range in a designated
font:
.LP
.RS
.nf
\fC\\indexentry{alpha|(bold}{1}
\\indexentry{alpha|)}{5}\fP
.fi
.RE
.LP
will become
.LP
.RS
\fC\\item alpha, \\bold{1--5}\fP
.RE
.LP
Several potential problems are worth mentioning.  First, entries like
.LP
.RS
.nf
\fC\\indexentry{alpha|(}{1}
\\indexentry{alpha|bold}{3}
\\indexentry{alpha|)}{5}\fP
.fi
.RE
.LP
will be interpreted as
.LP
.RS
\fC\\item alpha, \\bold{3}, 1--5\fP
.RE
.LP
but with a warning message in the transcript about encountering an
inconsistent page encapsulator.
An explicit range beginning in a Roman page number and ending
in Arabic is also considered an error.  In this instance, (if
possible) the range is broken into two subranges, one in Roman and the
other in Arabic.  For instance,
.LP
.RS
.nf
\fC\\indexentry{alpha|(}{i}
\\indexentry{alpha}{iv}
\\indexentry{alpha}{3}
\\indexentry{alpha|)}{7}\fP
.fi
.RE
.LP
will be turned into
.LP
.RS
\fC\\item alpha, i--iv, 3--7\fP
.RE
.LP
with a warning message in the transcript file complaining about an
illegal range formation.
.LP
Finally, every special symbol mentioned in this section may be
escaped by the
.B quote
operator (`"').  Thus
.LP
.RS
\fC\\indexentry{alpha"@beta}{1}\fP
.RE
.LP
will actually become
.LP
.RS
\fC\\item alpha@beta,  1\fP
.RE
.LP
as a result of executing
.IR makeindex .
The quoting power of
.B quote
is eliminated if it is immediately preceded
by
.B escape
(`\\').  For example,
.LP
.RS
\fC\\indexentry{f\\"ur}{1}\fP
.RE
.LP
becomes
.LP
.RS
\fC\\item f\\"ur, 1\fP
.RE
.LP
which represents an umlaut-accented `u' to the \*(TX family of
processors.
.LP
From version 2.11 of
.IR makeindex ,
the
.B quote
operator may quote
.I any
character in the range 1 .\|.\|. 255.   Character 0 is excluded because
it is used internally in the
.I makeindex
source code as a string terminator.  With this change, sort keys can
be created for all eight-bit characters except the character 0 (this
is
.I not
the digit zero).  The sorting order
is
.RS
.nf

punctuation characters (in ASCII order),
digits,
control characters (1 .\|.\|. 31),
space (32),
letters (ignoring case),
characters 127 .\|.\|. 255.

.fi
.RE
Here is an example showing the indexing of all printable ASCII
characters other than letters and digits, assuming the default
\*(TX format.  For convenience, the page number references are
the corresponding ASCII ordinal values.
.RS
.nf

\fC\\indexentry{" @"  (space)}{32}
\\indexentry{"!@"! (exclamation point)}{33}
\\indexentry{""@"" (quotation mark)}{34}
\\indexentry{"#@"\\# (sharp sign)}{35}
\\indexentry{"$@"\\$ (dollar sign)}{36}
\\indexentry{"%@"\\% (percent sign)}{37}
\\indexentry{"&@"\\& (ampersand)}{38}
\\indexentry{"<@"$<$ (left angle bracket)}{60}
\\indexentry{"=@"= (equals)}{61}
\\indexentry{">@"$>$ (right angle bracket)}{62}
\\indexentry{"?@"? (query)}{63}
\\indexentry{"@@"@ (at sign)}{64}
\\indexentry{"[@"[ (left square bracket)}{91}
\\indexentry{"\\@"\\verb=\\= (backslash)}{92}
\\indexentry{"]@"] (right square bracket)}{93}
\\indexentry{"^@"\\verb=^= (caret)}{94}
\\indexentry{"_@"\\verb=_= (underscore)}{95}
\\indexentry{"`@"\\verb=~= (grave accent)}{96}
\\indexentry{"{@"\\"{ (left brace)}{123}
\\indexentry{"|@"\\verb="|= (vertical bar)}{124}
\\indexentry{"}@"\\"} (right brace)}{125}
\\indexentry{"~@"\\verb=~= (tilde)}{126}\fP

.fi
.RE
Characters in the actual fields following the `@' character which
have special significance to \*(TX must be represented as control
sequences, or as math mode characters.  Note particularly how the
entries for the at sign, left and right braces, and the vertical
bar, are coded.  The index file output by
.I makeindex
for this example looks like this:
.RS
.nf

\fC\\begin{theindex}

  \\item ! (exclamation point), 33
  \\item " (quotation mark), 34
  \\item \\# (sharp sign), 35
  \\item \\$ (dollar sign), 36
  \\item \\% (percent sign), 37
  \\item \\& (ampersand), 38
  \\item $<$ (left angle bracket), 60
  \\item = (equals), 61
  \\item $>$ (right angle bracket), 62
  \\item ? (query), 63
  \\item @ (at sign), 64
  \\item [ (left square bracket), 91
  \\item \\verb=\\= (backslash), 92
  \\item ] (right square bracket), 93
  \\item \\verb=^= (caret), 94
  \\item \\verb=_= (underscore), 95
  \\item \\verb=~= (grave accent), 96
  \\item \\{ (left brace), 123
  \\item \\verb=|= (vertical bar), 124
  \\item \\} (right brace), 125
  \\item \\verb=~= (tilde), 126

  \\indexspace

  \\item   (space), 32

\\end{theindex}\fP
.fi
.RE
.\"=====================================================================
.SH "FILES"
.TP 2.7i
.I /usr/local/bin/makeindex
executable file
.TP
.I /usr/local/man/man1/makeindex.1
UNIX manual pages
.TP
.I /usr/local/lib/tex/macros/idxmac-amstex.tex
\*(TX macro file
.TP
.I /usr/local/lib/tex/macros/idxmac.tex
\*(TX macro file
.TP
.I /usr/local/lib/tex/macros/makeidx.doc
\*(TX macro file
.TP
.I /usr/local/lib/tex/macros/makeidx.sty
\*(TX macro file
.\"=====================================================================
.SH "SEE ALSO"
ditroff(1L),
latex(1L),
make.index (1L),
qsort(3),
tex(1L),
troff(1L)
.LP
.IR "\*(Uc Enhanced troff/\*(Ts \(em An Overview" ,
Richard P. C. Rodgers and Conrad Huang, LSMB Technical Report 90-2,
UCSF School of Pharmacy, San Francisco, 1990.
.LP
.IR "Index Preparation and Processing" ,
Pehong Chen and Michael A. Harrison,
.IR "Software: Practice and Experience" ,
.BR 19 (9),
897\(en915,
September 1988.
.LP
.IR "Automating Index Preparation" ,
Pehong Chen and Michael A. Harrison.  Technical Report 87/347,
Computer Science Division, University of California, Berkeley, 1987
(a \*(LX document supplied with
.IR makeindex ).
.LP
.IR "MakeIndex: An Index Processor for \*(LX" ,
Leslie Lamport, February 1987 (a \*(LX document supplied
with
.IR makeindex ).
.LP
.IR "Tools for Printing Indices" ,
Jon L. Bentley and Brian W. Kernighan,
.IR "Electronic Publishing \(em Origination, Dissemination, and Design" ,
1(1), 3\(en18, June 1988 (also available as: Computing Science
Technical Report No. 128,
AT&T Bell Laboratories, Murray Hill, NJ 07974, 1986).
.\"=====================================================================
.SH "AUTHOR"
Pehong Chen, Chen & Harrison International Systems, Inc.
Palo Alto, California, USA <chen@renoir.berkeley.edu>.
.br
Manual page extensively revised and corrected, and
.IR troff (1)
examples created by Richard P. C. Rodgers, UCSF School of Pharmacy,
San Francisco, CA, USA <rodgers@cca.ucsf.edu>, with later additions by
Nelson H. F. Beebe <beebe@math.utah.edu>.
.\"=====================================================================
.SH ACKNOWLEDGMENTS
Leslie Lamport contributed significantly to the design.
.\"
Michael Harrison provided valuable comments and suggestions.
.\"
Andreas Brosig contributed to the German word ordering.
.\"
The modification to the
.B \-ms
macros was derived from a method proposed by Ravi Sethi of AT&T
Bell Laboratories.
.PP
Nelson H. F. Beebe improved on the portable version, and maintains the
source distribution for the \*(TX Users Group.  He also instituted
major internal redesigns for speed and memory economization, removed
small limits on many object sizes, improved handling of composite page
numbers, and provided a large validation test suite to enhance
confidence in a correct installation of
.IR makeindex .
.PP
The
.I LOG
and
.I CONTRIB
files in the
.I makeindex
source distribution record other contributions.
.\"=====================================================================
.SH "AVAILABILITY"
.PP
The newest version of
.I makeindex
is maintained on the Internet host machine
.I ftp.math.utah.edu
in the directory tree
.IR /pub/tex/pub/makeindex .
The distribution is mirrored from there to the major Comprehensive
\*(TX Archive Network (CTAN) hosts,
.I ftp.dante.de
(Germany),
.I ftp.shsu.edu
(Texas, USA),
.I ftp.tex.ac.uk
(England), .\|.\|.
